import java.io.BufferedReader;
import java.io.FileReader;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.net.SocketAddress;

public class PortTester {

        public static void main(String[] argv) {
                
                String fileIn = "porttester.in";
                BufferedReader b = null;
                String readLine = null;
                
                try {
                        b = new BufferedReader(new FileReader(fileIn));
                        
                while ((readLine = b.readLine()) != null) {
                        
                                int length = readLine.length();
                                int leftParenthesis = readLine.indexOf("(");
                                int rightParenthesis = readLine.indexOf(")");
                                
                                if (length > 0 &&
                                        leftParenthesis > 0 &&
                                        rightParenthesis > 0 &&
                                        leftParenthesis < rightParenthesis) 
                                {
                                String server = readLine.substring(0,leftParenthesis);
                                int port = Integer.parseInt(readLine.substring(leftParenthesis+1,rightParenthesis));
                                
                                        try { 
                                                InetAddress addr = InetAddress.getByName(server);
                                                
                                                SocketAddress sockaddr = new InetSocketAddress(addr, port);
                        
                                                Socket sock = new Socket();
                        
                                                int timeoutMs = 3000; // 3 seconds
                                                sock.connect(sockaddr, timeoutMs);
                                                System.out.println("Able to connect to server=" + server + " port=" + port);
                                                sock.close();
                                        
                                        } catch (Exception ex) {
                                                System.err.println("Encountered exception for connecting to server=" + server + " port=" + port);
                                                System.err.println("Exception was " + ex);
                                        }
                                }
                        
                }

                } catch (Exception ex) {
                        System.err.println("Encountered exception " + ex);
                        System.err.println("Usage Notes: You are required to provide an input file named porttester.in");
                        System.err.println("Usage Notes: porttester.in should include a one per line list of server(port) to check");
                        System.err.println("Usage Notes: Below is an example of porttester.in");
                        System.err.println("server1(1414)");
                        System.err.println("server2(1414)");
                        System.err.println("Program will now end!");
                        System.exit(-1);
                }
                
                
                
        }

}